%define	CTVER	%{version}
%define	CDVER	1999.08.29
%define MDK_KBD_VER 20050108

%define major 0
%define fname console
%define libname %mklibname %fname %major

# /usr/lib/kbd/{conslefonts,consolemaps,keymaps} instead of
# /usr/share/{conslefonts,consolemaps,keymaps}
# FIXME: data really should really go to /usr/share/*
%define kbddir		%{_prefix}/lib/kbd
%define _datadir	%{kbddir}
%define _mandir		%{_prefix}/share/man

Summary:	Linux console tools
Name:		console-tools
Version:	0.2.3
Release:	%mkrel 63
Group:		Terminals
License:	GPL
URL:		http://lct.sourceforge.net/
Source0:	ftp://metalab.unc.edu/pub/Linux/system/keyboards/console-tools-%{CTVER}.tar.bz2
Source1:	ftp://metalab.unc.edu/pub/Linux/system/keyboards/console-data-%{CDVER}.tar.bz2
Source2:	keytable.init
Source3:	ftp://ftp.dementia.org/pub/linux/pc2sun.pl
Source4:	console-tools-ucwfonts.tar.bz2
Source5:	kbd-0.96-turkish.tar.bz2
Source6:	kbd-mdk-keymaps-%{MDK_KBD_VER}.tar.bz2
Source7:	configure_keyboard.sh
Source8:	ctools-cyr.tar.bz2
Patch0:		keytable.init.ppc.patch.bz2
Source10:	mac-keymaps.tar.bz2
Source11:	us-intl.kmap.gz

Requires(pre):	coreutils sed rpm-helper
BuildRequires:	flex libtool >= 1.3.3 sgml-tools automake1.7 automake1.4 autoconf2.5
BuildRequires:	gettext-devel
Requires:	grep /bin/gawk
Requires: initscripts
Buildroot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires(pre):	%{libname} = %{version}-%{release}
Patch5:		console-tools-0.2.3-docbook.patch.bz2
Patch6:		console-tools-rootpart.patch.bz2
Patch8:		console-tools-0.2.3-versioncoredump.patch.bz2
Patch9:		console-tools-0.2.3-noteuro.patch.bz2
Patch10:	console-data-1999.08.29-mandrake.patch.bz2
Patch11:	console-tools-0.2.3-tilde-with-twosuperior-in-french-keyboard.patch.bz2
Patch12:	console-tools-0.2.3-setkeycodes-fixargument.patch.bz2
Patch13:	console-tools-0.2.3-ppc-using-linux-keycodes.patch.bz2
Patch14:	http://www.links.nectec.or.th/~thep/th-console/console-data/console-data-thai_deb-1999.08.29-21.8.patch.bz2
Patch15:	http://www.links.nectec.or.th/~thep/th-console/console-tools/console-tools-thai_ksym.patch.bz2
Patch16:	console-tools-gcc33.patch.bz2
Patch17:	console-tools-start_unicode.patch.bz2
Patch18:	console-tools-0.2.3-compresscoredump.patch.bz2
Patch19:	console-tools-0.2.3-gcc3.4-fix.patch.bz2
Patch20:	console-data-1999.08.29-mac.patch.bz2
Patch21:	console-tools-0.2.3-fix-openvt-option--w.patch.bz2
Patch22:	console-tools-0.2.3-fix-fgconsole_exit_status.patch.bz2

%description
This package contains utilities to load console fonts and
keyboard maps.  It also includes a number of different fonts
and keyboard maps.

%package -n	%{libname}
Summary:	Libraries for console tools
Group:		System/Libraries
Provides:	lib%{fname} = %{version}-%{release}

%description -n	%{libname}
This package contains libraries for console tools

%package -n	%{libname}-devel
Summary:	Include and .so files for console tools
Group:		Development/Other
Requires(pre):	%{libname} = %{version}-%{release}
Obsoletes:	%{name}-devel
Provides:	%{name}-devel = %{version}-%{release}
Provides:	lib%{fname}-devel = %{version}-%{release}

%description -n	%{libname}-devel
This package contains include and .so files for console tools


%package -n	%{libname}-static-devel
Summary:	Static libraries for console tools
Group:		Development/Other
Requires(pre):		%{name}-devel = %{version}-%{release}
Obsoletes:	%{name}-static-devel
Provides:	%{name}-static-devel = %{version}-%{release}
Provides:	lib%{fname}-static-devel = %{version}-%{release}

%description -n	%{libname}-static-devel
This package contains static libraries for console tools.

%prep
%setup -n %{name}-%{CTVER} -q -a 1 -a4 -a5
cd console-data-%{CDVER}
%patch10 -p1
%patch20 -p1
cd ..

%patch5 -p1 -b ._db
%patch6 -p1 -b .rootpart
%patch8 -p1
%patch9 -p0
%patch11 -p1
%patch12 -p1

%ifarch ppc ppc64
%patch13 -p1
%endif

%patch14 -p0 -b .thai1
%patch15 -p1 -b .thai2
%patch16 -p0
%patch17 -p1
%patch18 -p1
%patch19 -p1 -b .gcc34
%patch21 -p1
%patch22 -p1

# adapt for gettext >= 0.14.2 (avoid patch)
grep -q gt_LC_MESSAGES /usr/share/aclocal/lcmessage.m4 &&
perl -pi -e 's/^(\s+)AM_(LC_MESSAGES)/${1}gt_${2}/' acinclude.m4 console-data-%{CDVER}/acinclude.m4

%build
%serverbuild
%ifarch %ix86
DISABLE_RESIZECONS=
%else
DISABLE_RESIZECONS=--disable-resizecons
%endif
aclocal-1.4
automake-1.4
export FORCE_AUTOCONF_2_5=1
CFLAGS="%optflags -D_GNU_SOURCE"
%configure2_5x --enable-localdatadir=%_sysconfdir/sysconfig/console $DISABLE_RESIZECONS
%make

cd console-data-%{CDVER}
aclocal-1.7
automake-1.7
CFLAGS="%optflags -D_GNU_SOURCE"
%configure2_5x --enable-localdatadir=%_sysconfdir/sysconfig/console $DISABLE_RESIZECONS
%make
cd -

%install
rm -fr %buildroot
install -d -m 0755 %buildroot/%_prefix

make DESTDIR=%{buildroot} install
cd console-data-%{CDVER}
make DESTDIR=%{buildroot} install
cd ..

# don't give loadkeys SUID perms
chmod 755 %buildroot/%{_bindir}/loadkeys

# other keymaps
tar jxf %SOURCE6 -C %buildroot/%{kbddir}/
tar jxf %SOURCE8 -C %buildroot/%{kbddir}/
	  
install -d -m 0755 %buildroot/%_sysconfdir/rc.d/init.d
install -m 0755 %SOURCE2 %buildroot/%_sysconfdir/rc.d/init.d/keytable
%ifarch ppc ppc64
bzcat %{PATCH0}|patch -d %buildroot/%_sysconfdir/rc.d/init.d -p0
%endif

install -d -m 0755 %buildroot/%_sysconfdir/profile.d
install -m 0755 %SOURCE7 %buildroot/%_sysconfdir/profile.d/configure_keyboard.sh

install -d -m 0755 %buildroot//bin
#for i in loadkeys consolechars unicode_start; do
for i in consolechars unicode_start kbd_mode; do
  mv %buildroot/%_bindir/$i %buildroot/bin
  ln -s ../../bin/$i %buildroot/%_bindir/$i
done

%ifnarch %ix86
rm -f %buildroot/%_mandir/man8/resizecons.8
%endif

chmod +x %buildroot/%_libdir/*.so*
# libraries must be accessible before partition mounting
# if we want to be able to load console font before partition mounting
mkdir -p  %buildroot/lib
mv %buildroot/%_libdir/*.so* %buildroot/lib

cp -aR console-data-%{CDVER}/doc/* doc

install -m644 -D include/lct/*.h %buildroot/%{_includedir}/lct/

# more mac keymaps on ppc 
%ifarch ppc ppc64
tar jxf %SOURCE10 -C %buildroot/%{kbddir}/keymaps 
%endif

# remove unneeded files
rm -rf %buildroot/%{kbddir}/keymaps/{amiga,atari,sun}
%ifnarch ppc ppc64
rm -rf %buildroot/%{kbddir}/keymaps/mac
%endif

# us-international keymap
install -m 0644 %{SOURCE11} %buildroot/%{kbddir}/keymaps/i386/qwerty/

%find_lang %name

%clean
rm -fr %buildroot

%post
%_post_service keytable
if [ -f %_sysconfdir/sysconfig/keyboard ] ; then
    . %_sysconfdir/sysconfig/keyboard
    if [ -n "$KEYTABLE" ] ; then
        KT=`echo $KEYTABLE | sed -e "s/.*\///g" | sed -e "s/\..*//g"`
		# perl-base is required by basesystem ...
		perl -pi -e "s/KEYTABLE=.*$/KEYTABLE=$KT/g" %_sysconfdir/sysconfig/keyboard
    fi
fi
if [ -f %_sysconfdir/sysconfig/i18n ] ; then
   . %_sysconfdir/sysconfig/i18n
   if [ -d %_sysconfdir/sysconfig/console ] ; then
      if [ -n "$SYSFONT" ]; then
         mkdir -p %_sysconfdir/sysconfig/console/consolefonts
         cp -f %{kbddir}/consolefonts/$SYSFONT* \
			%_sysconfdir/sysconfig/console/consolefonts
      fi
      if [ -n "$UNIMAP" ]; then
         mkdir -p %_sysconfdir/sysconfig/console/consoletrans
         cp -f %{kbddir}/consoletrans/$UNIMAP* \
			%_sysconfdir/sysconfig/console/consoletrans
      fi
      if [ -n "$SYSFONTACM" ]; then 
         mkdir -p %_sysconfdir/sysconfig/console/consoletrans
         cp -f %{kbddir}/consoletrans/$SYSFONTACM* \
			%_sysconfdir/sysconfig/console/consoletrans
      fi
   fi
fi

%preun
%_preun_service keytable

%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig

%files -f %name.lang
%defattr(-,root,root)
%doc README NEWS RELEASE
#
#
#
%config(noreplace) %_sysconfdir/profile.d/configure_keyboard.sh
#
%config(noreplace) %_sysconfdir/rc.d/init.d/keytable
#
#
%dir %{kbddir}
%{kbddir}/consolefonts
%{kbddir}/consoletrans
#
%dir %{kbddir}/keymaps
%{kbddir}/unidata
%{kbddir}/keymaps/include
# Warning: keyboards are not cpu-dependent but machine-dependent.
# How to distinguish Linux/PPC on Amiga/PPC (amiga kbd) and Linux/PPC
# on Apple/ppc (mac kbd) ?
#
# for now an ugly hack: ppc -> mac, sparc -> sun, i386/alpha -> i386
#%{kbddir}/keymaps/amiga
#%{kbddir}/keymaps/atari
#
# (fg) 20010411 Also ia64 has PC-like keyboards, added it here
#
# (sb) move to Linux keycodes PPC
#
# (OT) if all need it, why set an %ifarch
#%ifarch %ix86 alpha ia64 ppc x86_64 sparc
%{kbddir}/keymaps/i386
#%endif

# (sb) leave in the event user really wants mac keymaps
%ifarch ppc ppc64
%{kbddir}/keymaps/mac
%endif
/bin/unicode_start
/bin/consolechars
/bin/kbd_mode
%{_bindir}/charset
%{_bindir}/chvt
%{_bindir}/codepage
%{_bindir}/consolechars
%{_bindir}/deallocvt
%{_bindir}/dumpkeys
%{_bindir}/fgconsole
%{_bindir}/fix_bs_and_del
%{_bindir}/font2psf
%{_bindir}/getkeycodes
%{_bindir}/kbd_mode
%{_bindir}/loadkeys
%{_bindir}/loadunimap
%{_bindir}/mk_modmap
%{_bindir}/mapscrn
%{_bindir}/openvt
%{_bindir}/psfaddtable
%{_bindir}/psfgettable
%{_bindir}/psfstriptable
%ifarch %ix86
%{_bindir}/resizecons
%endif
%{_bindir}/saveunimap
%{_bindir}/screendump
%{_bindir}/setfont
%{_bindir}/setkeycodes
%{_bindir}/setleds
%{_bindir}/setmetamode
%{_bindir}/setvesablank
%{_bindir}/showcfont
%{_bindir}/showkey
%{_bindir}/splitfont
%{_bindir}/unicode_start
%{_bindir}/unicode_stop
%{_bindir}/vcstime
%{_bindir}/vt-is-UTF8
%{_bindir}/writevt
#
#
#
%{_mandir}/man1/*
%{_mandir}/man4/*
%{_mandir}/man5/*
%{_mandir}/man8/*

%files -n %{libname}
%defattr(-,root,root)
/lib/*.so.*


%files -n %{libname}-devel
%defattr(-,root,root)
%doc BUGS TODO doc/[cdf]* doc/keymaps doc/README* doc/*.txt
/lib/*.so
%{_libdir}/*.la
%dir %{_includedir}/lct
%{_includedir}/lct/*

%files -n %{libname}-static-devel
%defattr(-,root,root,-)
%_libdir/*.a

%changelog
* Sun Aug 19 2007 Bender the Build Bot <benderbot@pclinuxos.com> 0.2.3-63pclos2007
- Remove kbd provides and obsoletes

* Sun Jan 07 2007 Texstar <texstar@houston.rr.com> 
- fix dependencies

* Wed Nov 01 2006 Texstar <texstar@houston.rr.com>
- Build for PCLinuxOS 2007
